import Flutter
import UIKit
import AyetStudiosSDK

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
    
    var channel: FlutterMethodChannel!
    
    override func application(
        _ application: UIApplication,
        didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
    ) -> Bool {
        if #available(iOS 10.0, *) {
          UNUserNotificationCenter.current().delegate = self as UNUserNotificationCenterDelegate
        }
        let rootViewController : FlutterViewController = window?.rootViewController as! FlutterViewController
        channel = FlutterMethodChannel(name: "ios_native", binaryMessenger: rootViewController as! FlutterBinaryMessenger)
        channel.setMethodCallHandler {(call: FlutterMethodCall, result: FlutterResult) -> Void in
            switch(call.method) {
            case "init":
              if let args = call.arguments as? Dictionary<String, Any>,
                    let appKey = args["appKey"] as? String, let uid = args["uid"] as? String {
                   AyetSdk.sdkInit(appKey: appKey , userIdentifier: uid , callback: { available_currency , pending_currency , spent_currency in
                        print("Available currency:  \(available_currency)")
                    self.channel.invokeMethod("userAvailableBalance", arguments: AyetSdk.getAvailableCurrency())
                        print("Pending currency:    \(pending_currency)")
                      self.channel.invokeMethod("userPendingBalance", arguments:  AyetSdk.getPendingCurrency())
                    });
                   result(nil)
                    } else {
                    result(FlutterError.init(code: "errorInit", message: "Couldn't initialize Aye-Tstudios", details: nil))
                }
                break;
            case "show":
                    let placement = call.arguments as! String
                    let rootViewController = UIApplication.shared.keyWindow?.rootViewController
                      AyetSdk.showOfferwall(currentController: rootViewController!, adslotName: placement);
                
                break;
             case "sdkLogEnable":
                AyetSdk.sdkLogEnable()
                case "userAvailableBalance":
                    self.channel.invokeMethod("userAvailableBalance", arguments: AyetSdk.getAvailableCurrency())
                case "userPendingBalance":
                    self.channel.invokeMethod("userPendingBalance", arguments:  AyetSdk.getPendingCurrency())
                break;
            default: result(FlutterMethodNotImplemented)
            }
        }
        GeneratedPluginRegistrant.register(with: self)
        return super.application(application, didFinishLaunchingWithOptions: launchOptions)
        
    }
    
}
